require "adamantium"
require "rack"
require "rack-protection"
require "rack-body_serializer"
require "rack-authentication_bearer"
require "rack-body_deserializer"
require "rack-accept_setter"
require "rack-chunker"
require "rack-content_length_setter"
require "rack-runtime"
require "rack-log"
require "rack/cors"
require "scrawl"
require "active_record"

module Shogun
  require_relative "shogun/authorizer"
  require_relative "shogun/control"
  require_relative "shogun/database"
  require_relative "shogun/denormalizer"
  require_relative "shogun/dispatch"
  require_relative "shogun/endpoint"
  require_relative "shogun/normalizer"
  require_relative "shogun/presenter"
  require_relative "shogun/presenters"
  require_relative "shogun/server"
  require_relative "shogun/validator"
  require_relative "shogun/verifier"
  require_relative "shogun/version"
end
